#include <iostream>
#include <LEDA/integer.h>
#include <LEDA/rational.h>
#include <LEDA/bigfloat.h>
#include <LEDA/real.h>

using namespace std;

int
main()
{
  leda_integer  li  = 1999;
  leda_integer  zwo = 2; 

  leda_rational lr  = leda_rational(li) / zwo;
  cout << "rational: " << endl << lr << endl;

  leda_bigfloat lb  = leda_bigfloat(li) / zwo;
  cout << "bigfloat: " << endl << lb << endl;

  leda_real lreal   = leda_real(li) / zwo;
  cout << "real    : " << endl << lreal << endl;

  double  dblreal   = 1999.0 / 2.0;

  double  dblsqrt   = sqrt( dblreal);
  cout << endl << "doubles do ";
  if ( dblsqrt*dblsqrt != dblsqrt ) { cout << "NOT "; }
  cout << "guarantee exact computation." << endl;
  leda_real sqrt_lreal = sqrt( lreal);
  cout << endl << "leda_reals do ";
  if ( sqrt_lreal*sqrt_lreal != lreal ) { cout << "NOT "; }
  cout << "guarantee exact computation." << endl;

  return 0;
}
