#include <iostream>
#include <complex>
#include <cassert>
#include <LEDA/real.h>

using namespace std;

typedef leda_real           Real;
typedef complex<leda_real>  Complex;

int
main()
{
  Real re;
  Real im;
  cout <<         "Realteil:      ";
  cin  >>  re;  
  cout << endl << "Imaginaerteil: ";
  cin  >>  im;

  Complex c1( re, im);
  Complex c2 = sqrt(c1);
  Complex c3( - c2.real(), - c2.imag());
  // Complex c3 = -c2;

  assert( c1 == c2*c2 );
  assert( c1 == c3*c3 );

  cout << endl;
  cout << "+-(" << "re: " << c2.real() << ',' << "im: " << c2.imag() << ')';
  cout << endl;

  return 0;
}
