#include <iostream>
#include <climits>          // CHAR_BIT
#include <cassert>

using namespace std;

int
main()
{
  bool b      = true;
  bool b2     = false;
  
  char c      = 'a';
  char oo7    = '\007';
  char ziffer_null = '0';
  wchar_t wc  = L'a';

  signed char sc;
  short int s = -1881;      // decimal
  short s2    = s;
  int  i      = 0;          // decimal
  long l      = 56781234L;  // decimal

  unsigned char uc  = 8;    // decimal  
  unsigned short us = 020;  // octal  0...
  unsigned int ui   = 32;   // decimal
  unsigned long ul  = 0x10; // hexadecimal  0x... 0X...

  enum Aufzaehlungstyp { NEGATIVE = -1, ZERO = 0, POSITIVE = 1 };
  i = NEGATIVE;

  float f  =  3.14159f;
  double d =  2.718281828459045235;
  long double ld = 3.1415926535897932384646L;

  d = f;
  ld = d;
  f = ld;

  cout << oo7 << endl;
  cout << "Number of bits in a char:      " << CHAR_BIT << endl; 

  assert( sizeof(char) == 1 );
  assert( sizeof(char) <= sizeof(short) );
  assert( sizeof(short) <= sizeof(int) );
  assert( sizeof(int) <= sizeof(long) );

  assert( sizeof(char) <= sizeof(wchar_t) );
  assert( sizeof(wchar_t) <= sizeof(long) );

  assert( sizeof(char) == sizeof( signed char) );
  assert( sizeof(char) == sizeof( unsigned char) );
  assert( sizeof(short) == sizeof( unsigned short) );
  assert( sizeof(int) == sizeof( unsigned int) );
  assert( sizeof(long) == sizeof( unsigned long) );
 
  assert( sizeof(float) <= sizeof(double) ); 
  assert( sizeof(double) <= sizeof(long double) ); 

  assert( sizeof(bool) >= 1 );
  
  cout << "Number of bits in wchar_t:     " << sizeof(wchar_t)*CHAR_BIT << endl;
  cout << endl;
  cout << "Number of bits in bool:        " << sizeof(bool)*CHAR_BIT << endl;
  cout << endl;
  cout << "Number of bits in short:       " << sizeof(short)*CHAR_BIT << endl;
  cout << "Number of bits in int:         " << sizeof(int)*CHAR_BIT << endl;
  cout << "Number of bits in long:        " << sizeof(long)*CHAR_BIT << endl;
  cout << endl;
  cout << "Number of bits in float:       " << sizeof(float)*CHAR_BIT << endl;
  cout << "Number of bits in double:      " << sizeof(double)*CHAR_BIT << endl;
  cout << "Number of bits in long double: " << sizeof(long double)*CHAR_BIT << endl;
  cout << oo7;

  return 0;
}
