#include <iostream>
#include "point.h"

using namespace std;

int zero_initialized;
const float pi = 3.14159f;

int
main()
{
  int not_well_defined;
  cout << "value of global variable: " <<  zero_initialized << endl;
  cout << "value of local variable:  " <<  not_well_defined << endl;

  float f = 1.0;
  cout << "f: " << f << endl;

  float* pf = &f;    // pointer to float
  *pf = -1.0;
  cout << "f: " << f << endl;

  // pf = &pi;       // assignment to `float *' from `const float *' discards qualifiers
  const float* pcf = &f;
  // *pcf = 2.0;     // assignment of read-only location
  
  float* const cpf = &f;  
  // cpf = &pi;      // assignment to `float *' from `const float *' discards qualifiers
  float f2;
  // cpf = &f2;      // assignment of read-only variable `cpf'

  float fv[3];
  fv[0] = f;
  fv[1] = pi;
  fv[2] = *cpf;
  float fv2[3] = {1.0, 2.0, 4.0};
  pf = fv2;
  cout << endl << "pf: " << *pf << endl;
  pf += 1;
  cout << "pf: " << *pf << endl; 

  Point pv[4];
  // more_types.C:42: no matching function for call to `Point::Point ()'
  // point.h:8: candidates are: Point::Point(const float &, const float &)
  // point.h:19:                 Point::Point(const Point &)

  const char* str0 = "Hello";
  char* str1       = "again";   // legalized!
  cout << str0 << ' ' << str1 << endl;  

  return 0;
}
