#include <iostream>
#include <vector>

using namespace std;

void primes_up_to( unsigned long n)
{
  unsigned long j = 0;
  unsigned long p = 3;
  unsigned long q = 3;
  unsigned long m = (n+1)/2 - 1;

  vector<bool>  bits(m, true);

  cout << "2";

  while ( q < m )   // p^2 > n ?
  {
    if ( bits[j] )
    {
      // p = 2j + 3 ist prim
      cout << " - " << p;
      unsigned long k;   // k = index von p^2
      for ( k = q; k < m; k += p )
        bits[k] = false;
    }
    j++;           // naechste ungerade Zahl
    p += 2;        // p = 2j + 3;
    q += 2*p - 2;  // q = 2j^2 + 6j + 3, index von p^2
  }

  for ( ; j < m; j++, p +=2 )
  {
    if ( bits[j] )
    {
      // p = 2j + 3 ist prim
      cout << " - " << p;
    }
  }
}

int
main( int argc, char* argv[])
{
  if ( argc != 2 ) 
  {
    cerr << "Usage: primes2 integer_bound" << endl;
    return 1;
  }
  int N = atoi( argv[1]);

  primes_up_to( N);
  cout << endl;

  return 0;
}
